package org.gcube.application.geoportal.common.model.document.filesets;

import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

public class GCubeSDILayer extends Materialization{

    @Data
    @NoArgsConstructor
    public static class BBOX {

        public static final BBOX WORLD=new BBOX(180d,90d,-180d,-90d);

        public static final String MAX_X="maxX";
        public static final String MAX_Y="maxY";
        public static final String MIN_X="minX";
        public static final String MIN_Y="minY";

        public BBOX(Double maxX,Double maxY,Double minX,Double minY){
            this.maxX=maxX;
            this.minX=minX;
            this.maxY=maxY;
            this.minY=minY;
        }

        private Double maxY;
        private Double maxX;
        private Double minY;
        private Double minX;
    }


    public static final String GCUBE_SDY_LAYER_TYPE="gcube-sdi-layer";
    public static final String OGC_LINKS="ogcLinks";
    public static final String B_BOX = "bbox";
    public static final String PLATFORM_INFO="platformInfo";

    public GCubeSDILayer(){
        super(GCUBE_SDY_LAYER_TYPE);
    }

    public List getOGCLinks(){return this.get(OGC_LINKS, List.class);}
    public BBOX getBBox(){return this.get(B_BOX,BBOX.class);}
    public List getPlatformInfo(){return this.get(PLATFORM_INFO,List.class);}

}
