package org.gcube.application.geoportal.common.model.profile;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.bind.annotation.XmlRootElement;

import com.vdurmont.semver4j.Semver;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.gcube.application.geoportal.common.model.document.accounting.AccountingInfo;

@Data
@NoArgsConstructor
@XmlRootElement
public class Profile{

	private String id;
	private Semver version;

	private String name;
	private String description;
	private AccountingInfo creationInfo;

	private Field schema;

	private List<HandlerDeclaration> handlers;


	private List<DataAccessPolicy> dataAccessPolicies;

	/**
	 * Returns map Type -> Handler Declaration
	 * @return
	 */
	public Map<String,List<HandlerDeclaration>> getHandlersMap(){
		HashMap<String,List<HandlerDeclaration>> toReturn=new HashMap<>();
		handlers.forEach(h->{
			if(!toReturn.containsKey(h.getType()))
				toReturn.put(h.getType(),new ArrayList<>());
			toReturn.get(h.getType()).add(h);
		});
		return toReturn;
	}


}
